//+------------------------------------------------------------------------------------------+
//|                                              Expert Advisor based on the MARSI.ver 1.mq4 |
//|                                       Copyright  2012, Vasili Mailto and Andrey Serikov |
//+------------------------------------------------------------------------------------------+
#property copyright "Vasili  Mailto and Andrey  Serikov"
#property link      "vasssay@yandex.ru and passiusnet@yandex.ru"

//--- input parameters
extern double    lot=0.1;//  
extern int       take=50;//  
extern int       loss=50;//  
extern int       key=2032;//MagicNumner
//   
extern int      DopStep=250;//         
extern double   DopLot=0.2;//  
extern int      Doploss=30;//      0   
extern int      Doptake=30;//      0   




//  RSI
extern string indName="MARSI";
//   
extern int       level1=40;
extern int RSIPeriod1=6;
extern int MA1=4;
extern int ma_method_ma1 =1;
/*
MODE_SMA 0    
MODE_EMA 1    
MODE_SMMA 2    
MODE_LWMA 3 -   
*/
//   
extern int       level2=60;
extern int RSIPeriod2=6;
extern int MA2=4;
extern int ma_method_ma2 =1;
/*
MODE_SMA 0    
MODE_EMA 1    
MODE_SMMA 2    
MODE_LWMA 3 -   
*/
// 
extern bool usetrailing = true; // true- ,  false - 
extern int trailingstop=15;     //  
extern int tralStep=1;// 



int slip=5;

int start()
  {
   
   double rsi1=iCustom(Symbol(),Period(),indName,RSIPeriod1,MA1, ma_method_ma1,1,1);
   double rsip1=iCustom(Symbol(),Period(),indName,RSIPeriod1,MA1, ma_method_ma1,1,2);
   double rsi2=iCustom(Symbol(),Period(),indName,RSIPeriod2,MA2, ma_method_ma2,1,1);
   double rsip2=iCustom(Symbol(),Period(),indName,RSIPeriod2,MA2, ma_method_ma2,1,2);
   //Comment(rsi," ",rsip);
   /*
   double rsi=iRSI(Symbol(),Period(),periodRSI,applied_priceRSI,1);
   double rsip=iRSI(Symbol(),Period(),periodRSI,applied_priceRSI,2);*/
   
  
   if(rsip1<level1 && rsi1>=level1 && totalO(OP_BUY,key)==0)                
    openorder(OP_BUY,lot,take,loss);
   if(rsip1>level1 && rsi1<=level1 && totalO(OP_BUY,key)!=0)                
    close_working(key,OP_BUY);
  
   if(rsip2>level2 && rsi1<=level2 && totalO(OP_SELL,key)==0)                
    openorder(OP_SELL,lot,take,loss);
   if(rsip2<level2 && rsi2>=level2 && totalO(OP_SELL,key)!=0)                
    close_working(key,OP_SELL);
    
    //2.    
    if(totalO(-1,key)!=0)//  
     {
     
        double prB=0;
        double prS=0;
        int    tikB=0;
        int    tikS=0;
         for(int i=0; i<OrdersTotal(); i++)
                {  
                  if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))continue;
                  if(OrderSymbol() !=Symbol()|| OrderMagicNumber()!=key) continue; 
                  if(OrderType()==OP_BUY) { prB=ND(OrderOpenPrice());tikB=OrderTicket();}
                  if(OrderType()==OP_SELL){ prS=ND(OrderOpenPrice());tikS=OrderTicket();}
                } 
     }
    
    //        
     if(totalO(OP_BUY,key)==1)
      if(rsi1>=level1)
       if(ND(Ask)-prB>=DopStep*Point)
         {
          openorder(OP_BUY,DopLot,Doptake,Doploss);
          if(Doploss!=0)
           {
            if(OrderSelect(tikB,SELECT_BY_TICKET,MODE_TRADES))
             OrderModify(tikB,ND(OrderOpenPrice()),ND(Ask-Doploss*Point),ND(OrderTakeProfit()),OrderExpiration(),CLR_NONE);
           }
         } 
      
     if(totalO(OP_SELL,key)==1)
      if(rsi1<=level2)
       if(prS-ND(Bid)>=DopStep*Point)
         {
          openorder(OP_SELL,DopLot,Doptake,Doploss);
          if(Doploss!=0)
           {
            if(OrderSelect(tikS,SELECT_BY_TICKET,MODE_TRADES))
             OrderModify(tikS,ND(OrderOpenPrice()),ND(Bid+Doploss*Point),ND(OrderTakeProfit()),OrderExpiration(),CLR_NONE);
           }
         } 
       
    
    //
    if(usetrailing)
       Trail(key);
   return(0);
  }
//+------------------------------------------------------------------+
//    
double ND(double price)
{
return(NormalizeDouble(price,Digits));
} 

//1.     
/*  
 
int type (if -1 all type)
OP_BUY 0  
OP_SELL 1  
OP_BUYLIMIT 2   BUY LIMIT 
OP_SELLLIMIT 3   SELL LIMIT 
OP_BUYSTOP 4   BUY STOP 
OP_SELLSTOP 5   SELL STOP 
int _key MagicNumber

*/
int totalO(int type,int _key)
 {
       int TotalNumber = 0;  
              for(int i=0; i<OrdersTotal(); i++)
                {  
                  if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))continue;
                  if(OrderSymbol() !=Symbol()|| OrderMagicNumber()!=_key) continue; 
                  if (OrderType()==type||type==-1){
                  TotalNumber++;}
                } 
              return(TotalNumber); 
 }
//+------------------------------------------------------------------+
/* 

int type =   
OP_BUY 0  
OP_SELL 1  
OP_BUYLIMIT 2   BUY LIMIT 
OP_SELLLIMIT 3   SELL LIMIT 
OP_BUYSTOP 4   BUY STOP 
OP_SELLSTOP 5   SELL STOP 
double lot   - volume
int    slip  - slippage
double price - open price
int _loss - stoploos if =0 do not Set
int _take - takeprofit if =0 do not Set
int _key  - MagicNumber 
*/
void openorder(int type,double lot,int tp ,int ls)
{
  RefreshRates();
  string comm="Andre";
  if(type==OP_BUY || type==OP_BUYSTOP){
  color col=Blue;
  double price=ND(Ask);
    if(tp==0)double _take=0;else _take=price+tp*Point;
    if(ls==0)double _loss=0;else _loss=price-ls*Point;}
 
 if(type==OP_SELL || type==OP_SELLSTOP){
        col=Red;
        price=ND(Bid);  
    if(tp==0)       _take=0;else _take=price-tp*Point;
    if(ls==0)       _loss=0;else _loss=price+ls*Point;}
 
         int tik=OrderSend(Symbol(),type,lot,price,slip,_loss,_take,comm,key,0,col);
         if(tik!=-1)return(0);
         Print(" "+GetLastError()," t=",type," P=",price," s=",_loss," t=",_take);
         Sleep(1000);
}

 ///   
/*
 
int type   = -1  
int type (if -1 all type)
OP_BUY 0  
OP_SELL 1  
OP_BUYLIMIT 2   BUY LIMIT 
OP_SELLLIMIT 3   SELL LIMIT 
OP_BUYSTOP 4   BUY STOP 
OP_SELLSTOP 5   SELL STOP 
int _key MagicNumber
*/

void close_working(int _key, int type)
{
int kol=OrdersTotal();
for (int i=kol; i>=0; i--)
   {
   while(!IsTradeAllowed()) Sleep(1000);
   //Print(i," ",OrderSelect(i,SELECT_BY_POS,MODE_TRADES) ," ",OrderTicket()," ",kol);
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol() == Symbol() && OrderMagicNumber()==_key && (OrderType()==type || type==-1)  ){ 
      if (OrderType()==OP_BUY ) OrderClose (OrderTicket(),OrderLots(),ND(Bid),slip);
      if (OrderType()==OP_SELL) OrderClose (OrderTicket(),OrderLots(),ND(Ask),slip);
      if (OrderType()>1 ) OrderDelete(OrderTicket(),CLR_NONE);
      if(GetLastError()!=0)Print("  =",GetLastError());
   }
   
}
}        
//      
int lastBarClose()
{
int kol=OrdersHistoryTotal();
int bar=10;
for (int i=kol; i>=0; i--)
   {
      
     if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY) && OrderSymbol() == Symbol() && OrderMagicNumber()==key && OrderType()<=1  )
     {
      bar=iBarShift(Symbol(),0,OrderCloseTime(),false);
      break;
     } 
   }  
   
   return(bar);  
}

//
void Trail(int _key)
{  
   for(int i=0; i<OrdersTotal(); i++)
      if (OrderSelect(i,SELECT_BY_POS) && OrderSymbol()==Symbol() && OrderMagicNumber()==_key)
      {
         if (OrderType()==OP_BUY && (ND(Bid)>OrderStopLoss()+(trailingstop+tralStep)*Point ||OrderStopLoss()==0) )
              if (!OrderModify(OrderTicket(),OrderOpenPrice(),ND(Bid)-trailingstop*Point,ND(OrderTakeProfit()),0))
              {}
         if (OrderType()==OP_SELL && (ND(Ask)<OrderStopLoss()-(trailingstop+tralStep)*Point || OrderStopLoss()==0))
            if (!OrderModify(OrderTicket(),OrderOpenPrice(),ND(Ask)+trailingstop*Point,ND(OrderTakeProfit()),0))
               {}
      }
}


